#ifndef FD_READ_WRITE_XLSX_HPP
#define FD_READ_WRITE_XLSX_HPP

// This header is shared between ''fd-read-xlsx.hpp” and ''fd-write-xlsx.hpp”.

namespace fd_read_write_xlsx {

using str_t = std::string;

// Representation of a cell: std::variant of std::monostate, string, int64_t and
// double. A int64_t is choosen for int: the size is like the size of a double.
// ''monostate” when the cell is empty.
using cell_t = std::variant<std::monostate, str_t, int64_t, double>;

// Type of the table returned by the read function.
using table_t = std::vector<std::vector<cell_t>>;

// A row of this table.
using row_t = std::vector<cell_t>;

} // namespace fd_read_write_xlsx
#endif // FD_READ_WRITE_XLSX_HPP
