#ifndef FD_WRITE_XLSX_HPP
#define FD_WRITE_XLSX_HPP

#include <cmath>
#include <cstring>
#include <iostream>
#include <stdexcept>
#include <string>
#include <variant>
#include <vector>
#include <zip.h>

#include "fd-read-write-xlsx.hpp"

#define FD_WRITE_XLSX_SHOW(arg) std::cout << #arg << '{' << (arg) << '}' << std::endl;

namespace fd_write_xlsx {

using str_t = std::string;

struct Empty
{
	friend std::ostream& operator<<(std::ostream& stream, Empty empty) { return stream; }
};

// Representation of a cell: std::variant of std::monostate, string, int64_t and
// double. A int64_t is choosen for int: the size is like the size of a double.
// ''monostate” when the cell is empty.
using cell_t = fd_read_write_xlsx::cell_t;

// Type of the sheet using by the write function.
using sheet_t = fd_read_write_xlsx::table_t;
using table_t = fd_read_write_xlsx::table_t;

// A row of this sheet.
using row_t = fd_read_write_xlsx::row_t;

// Write the contents of the ''sheet” sheet into a Microsoft xlsx workbook and
// save it in the ''xlsx_file_name” file.
void
write(str_t const& xlsx_file_name, sheet_t const& sheet);
} // namespace fd_write_xlsx
#endif // FD_WRITE_XLSX_HPP
