// This class represents an individual of the population.
struct Individual
{
	// Defaut ctor. Initialize the ''id_number” data member to zero, the data members of type ''float”
	// to NaN value, the data member of type ''msl::Individual *” to nullptr value and the data member
	// of type ''uint8_t” to zero. The ''flags_” data member is initialized by default to false ; then
	// the flag ''alive” is equal to false.
	Individual()
	  : id_number{}
	  , birthday
	{
		msl::days_from_civil(0, 1, 1)
	}
	// ''float” type data members.
#define CTG(prm, format) /* nothing */
#define FLG(prm)         /* nothing */
#define FLT(prm)                                                                                   \
	, prm                                                                                            \
	{                                                                                                \
		std::numeric_limits<float>::quiet_NaN()                                                        \
	}
#define LNK(prm)                                                                                   \
	, prm##_weight                                                                                   \
	{                                                                                                \
		std::numeric_limits<float>::quiet_NaN()                                                        \
	}
#define PTR(prm) /* nothing */
#include "msl-variables.cpp"
#undef CTG
#undef FLG
#undef FLT
#undef LNK
#undef PTR
	// ''msl::Individual *” type data members.
#define LNK(prm)                                                                                   \
	, prm##_next                                                                                     \
	{                                                                                                \
		nullptr                                                                                        \
	}
#define FLT(prm)         /* nothing */
#define FLG(prm)         /* nothing */
#define CTG(prm, format) /* nothing */
#define PTR(prm)                                                                                   \
	, prm                                                                                            \
	{                                                                                                \
		nullptr                                                                                        \
	}
#include "msl-variables.cpp"
#undef CTG
#undef FLG
#undef FLT
#undef LNK
#undef PTR
	// ''uint8_t” type data members.
#define CTG(prm, format)                                                                           \
	, prm {}
#define LNK(prm) /* nothing */
#define FLT(prm) /* nothing */
#define FLG(prm) /* nothing */
#define PTR(prm) /* nothing */
#include "msl-variables.cpp"
#undef PTR
#undef CTG
#undef FLG
#undef FLT
#undef LNK
	{
		set_one(true);
	}
	// Forbid the copy ctor.
	Individual(msl::Individual const&) = delete;
	// The STL vector wants the move ctor to grow if necessary.
	Individual(msl::Individual&&)
	{
		std::cerr << "The program attempts to move an instance of ''msl::Individual”." << std::endl;
		exit(1);
	}
	// The address is used to test the equality.
	bool operator==(msl::RefConst other) const
	{
		return this == &other;
	}
	// The enum struct FLAGS_ { ..., flags_nr_ }.
	// Let us assume that you have ''FLG(female)'' and ''LNK(family)'' in the variable list.
	// The goal is to generate:
	// enum struct FLAGS_ { alive, female, family_head, flags_nr_ } ;
	// The ''flags_nr_” value is then the number of binary attributes, used in the ''std::bitset''
	// data member.
	enum struct FLAGS_
	{
		alive,
		one,
#define CTG(prm, format) /* nothing */
#define FLG(prm) prm,
#define FLT(prm) /* nothing */
#define LNK(prm) prm##_head,
#define PTR(prm) /* nothing */
#include "msl-variables.cpp"
#undef PTR
#undef CTG
#undef FLG
#undef FLT
#undef LNK
		flags_nr_
	};
	// The individual number.
	size_t id_number;
	int birthday;
	// All the binary attributes are managed by a ''std::bitset”.
	std::bitset<static_cast<int>(msl::Individual::FLAGS_::flags_nr_)> flags_;
	// The data members. The macro ''LNK(family)” generates two data members: ''family_next” and
	// ''family_weight”; ''family_next” is a pointer to the next individual in the family (the pointer
	// is a pointer to the first individual for the last individual in the family as the list is a
	// circular one). The macro ''FLT(x)” generates one data member, ''x”, of type float.  The macro
	// ''CTG(i)” generates one data member, ''i”, of type uint8_t. The macro ''PTR(partner)” generates
	// one data membre, ''partner”, of type msl::Individual*. To minimise padding, the data members of
	// same type are putted together.

	// Float data members.
#define LNK(prm) float prm##_weight;
#define FLT(prm) float prm;
#define FLG(prm)         /* nothing */
#define CTG(prm, format) /* nothing */
#define PTR(prm)         /* nothing */
#include "msl-variables.cpp"
#undef PTR
#undef CTG
#undef FLG
#undef FLT
#undef LNK
	// Pointer data members.
#define LNK(prm) msl::Individual* prm##_next;
#define FLT(prm)         /* nothing */
#define FLG(prm)         /* nothing */
#define CTG(prm, format) /* nothing */
#define PTR(prm) msl::Individual* prm;
#include "msl-variables.cpp"
#undef PTR
#undef CTG
#undef FLG
#undef FLT
#undef LNK
	// uint8_t data members.
#define LNK(prm) /* nothing */
#define FLT(prm) /* nothing */
#define FLG(prm) /* nothing */
#define CTG(prm, format) uint8_t prm;
#define PTR(prm) /* nothing */
#include "msl-variables.cpp"
#undef PTR
#undef CTG
#undef FLG
#undef FLT
#undef LNK

	// The getters and setters. We generate a getter only for flag variables, stored in the bitset,
	// and for ''PTR” variables.
	//
	// The macro ''LNK(family)” generates
	//   - 1 getter: ''family_head()”
	//   - 3 setters: ''set_family_head(arg)”, ''set_family_next(arg)” and ''set_family_weight(arg)”
	//
	// The macro ''FLT(x)” generates one setter ''set_x(arg)” and one getter ''get_x()'' which test
	// for missing value.
	//
	// The macro ''FLG(female)” generates one getter ''female()” and one setter ''set_female(arg)”.
	//
	// The macro ''CTG(cat)” generates one setter ''set_cat(arg)”.
	//
	// The macro ''PTR(partner)” generates one getter ''get_partner()”, one tester ''has_partner()”
	// and one setter ''set_partner(arg)”.
	//
	// The setters return a ref to the invidual: you can link up assignations.

	// The setter for the individual number.
	msl::Ref set_id_number(size_t arg)
	{
		id_number = arg;
		return *this;
	}
	// The setter for the birthday.
	msl::Ref set_birthday(int date)
	{
		birthday = date;
		return *this;
	}
	msl::Ref set_birthday_ymd(int y, unsigned m, unsigned d)
	{
		birthday = days_from_civil(y, m, d);
		return *this;
	}
#define LNK(prm)                                                                                   \
	bool prm##_head() const                                                                          \
	{                                                                                                \
		return flags_[static_cast<int>(msl::Individual::FLAGS_::prm##_head)];                          \
	}                                                                                                \
	msl::Ref set_##prm##_head(bool arg)                                                              \
	{                                                                                                \
		flags_[static_cast<int>(msl::Individual::FLAGS_::prm##_head)] = arg;                           \
		return *this;                                                                                  \
	}                                                                                                \
	msl::Ref set_##prm##_next(msl::Ref arg)                                                          \
	{                                                                                                \
		prm##_next = &arg;                                                                             \
		return *this;                                                                                  \
	}                                                                                                \
	msl::Ref set_##prm##_weight(float arg)                                                           \
	{                                                                                                \
		prm##_weight = arg;                                                                            \
		return *this;                                                                                  \
	}
#define FLT(prm)                                                                                   \
	msl::Ref set_##prm(float arg)                                                                    \
	{                                                                                                \
		prm = arg;                                                                                     \
		return *this;                                                                                  \
	}                                                                                                \
	/* Only the declaration as we need the definition of the ''dump'' function. */                   \
	float prm##_() const;
#define FLG(prm)                                                                                   \
	bool prm() const                                                                                 \
	{                                                                                                \
		return flags_[static_cast<int>(msl::Individual::FLAGS_::prm)];                                 \
	}                                                                                                \
	msl::Ref set_##prm(bool arg)                                                                     \
	{                                                                                                \
		flags_[static_cast<int>(msl::Individual::FLAGS_::prm)] = arg;                                  \
		return *this;                                                                                  \
	}
#define CTG(prm, format)                                                                           \
	msl::Ref set_##prm(uint8_t arg)                                                                  \
	{                                                                                                \
		prm = arg;                                                                                     \
		return *this;                                                                                  \
	}
#define PTR(prm)                                                                                   \
	msl::RefConst get_##prm() const                                                                  \
	{                                                                                                \
		return *prm;                                                                                   \
	}                                                                                                \
	bool has_##prm() const                                                                           \
	{                                                                                                \
		return prm != nullptr;                                                                         \
	}                                                                                                \
	msl::Ref set_##prm(msl::RefConst arg)                                                            \
	{                                                                                                \
		prm = const_cast<msl::Individual*>(&arg);                                                      \
		return *this;                                                                                  \
	}                                                                                                \
	msl::Ref symmetric_set_##prm(msl::Ref arg)                                                       \
	{                                                                                                \
		prm = &arg;                                                                                    \
		arg.prm = this;                                                                                \
		return *this;                                                                                  \
	}
	FLG(alive)
	FLG(one)
#include "msl-variables.cpp"
#undef PTR
#undef CTG
#undef FLG
#undef FLT
#undef LNK

	// The generic function which makes a subset.
	// ''head_ptr” is a pointer of the function member which returns the head flag.
	// ''set_head_ptr” is a pointer of the function member which sets the head flag.
	// ''next_ptr” is the data member which gives the next element in the subset.
	// Example of use:
	//       generic_merge_subset<
	//          &msl::Individual::family_head,
	//          &msl::Individual::set_family_head,
	//          &msl::Individual::family_next>(...)
	template<bool (msl::Individual::*head_ptr)() const,
	         msl::Ref (msl::Individual::*set_head_ptr)(bool),
	         msl::Individual* msl::Individual::*next_ptr>
	msl::Ref generic_merge_subset(msl::Ref other, char const* f_name)
	{
		assert(this != &other);
		// Get the head of the this subset : this head becomes the head on the new subset.
		msl::Ref head{ generic_get_subset_head<head_ptr, next_ptr>(*this, f_name) };
		// Go to the end of this subset.
		auto ptr{ &head };
		size_t m{};
		while (ptr->*next_ptr != &head) {
			ptr = ptr->*next_ptr;
			if (ptr == nullptr) {
				std::cerr << "Oups 3" << std::endl;
				// dump(*this);
				exit(1);
			}
			if (++m > 10000) {
				std::cerr << "Oups 4" << std::endl;
				// dump(*this);
				MSL_SHOW(f_name)
				exit(1);
			}
		}
		// Get the head of other subset : this head is no longer the head on the new subset.
		msl::Ref other_head{ generic_get_subset_head<head_ptr, next_ptr>(other, f_name) };
		(other_head.*set_head_ptr)(false);
		// Link the end of the previous subset to the other_head of this subset.
		ptr->*next_ptr = &other_head;
		// Go to the end of this subset.
		ptr = &other_head;
		m = 0;
		while (ptr->*next_ptr != &other_head) {
			ptr = ptr->*next_ptr;
			if (ptr == nullptr) {
				std::cerr << "Oups 3" << std::endl;
				// dump(*this);
				exit(1);
			}
			if (++m > 10000) {
				std::cerr << "Oups 4" << std::endl;
				// dump(*this);
				MSL_SHOW(f_name)
				exit(1);
			}
		}
		// Close the circular list: the next data member of the last individual is the address of the
		// head.
		ptr->*next_ptr = &head;
		return *this;
	}
	template<bool (msl::Individual::*head_ptr)() const,
	         msl::Ref (msl::Individual::*set_head_ptr)(bool),
	         msl::Individual* msl::Individual::*next_ptr>
	msl::Ref generic_lock_and_merge_subset(msl::Ref other, char const* f_name)
	{
		// Scoped lock to ensure exclusive acces to data.
		std::lock_guard<std::mutex> lock{ msl::global_lock };
		return generic_merge_subset<head_ptr, set_head_ptr, next_ptr>(other, f_name);
	}

// Declare and define the ''*_size” function member. Also, declare and define the
// factory function of the forward iterator over the subset. Finally, declare the ''for_each_*”
// function, the ''weighted_sum_*_head” and the ''weighted_sum_*_head_by”.
#define LNK(prm)                                                                                   \
                                                                                                   \
	/* Like inline size_t family_size() const */                                                     \
	inline size_t prm##_size() const                                                                 \
	{                                                                                                \
		return generic_subset_size<&msl::Individual::prm##_head, &msl::Individual::prm##_next>(*this); \
	}                                                                                                \
                                                                                                   \
	/* Like inline msl::Ref get_family_head() */                                                     \
	inline msl::Ref get_##prm##_head()                                                               \
	{                                                                                                \
		return generic_get_subset_head<&msl::Individual::prm##_head, &msl::Individual::prm##_next>(    \
		  *this, #prm);                                                                                \
	}                                                                                                \
                                                                                                   \
	/* The const version */                                                                          \
	inline msl::RefConst get_##prm##_head() const                                                    \
	{                                                                                                \
		return generic_get_subset_head<&msl::Individual::prm##_head, &msl::Individual::prm##_next>(    \
		  *this, #prm);                                                                                \
	}                                                                                                \
                                                                                                   \
	/* Like inline auto over_family() */                                                             \
	inline auto over_##prm()                                                                         \
	{                                                                                                \
		return generic_over_subset<&msl::Individual::prm##_next>(*this);                               \
	}                                                                                                \
                                                                                                   \
	/* Const version */                                                                              \
	inline auto over_##prm() const                                                                   \
	{                                                                                                \
		return generic_over_subset<&msl::Individual::prm##_next>(*this);                               \
	}                                                                                                \
	/* Like inline msl::Ref merge_family(msl::Ref other) */                                          \
	inline msl::Ref merge_##prm(msl::Ref other)                                                      \
	{                                                                                                \
		return this->generic_lock_and_merge_subset<&msl::Individual::prm##_head,                       \
		                                           &msl::Individual::set_##prm##_head,                 \
		                                           &msl::Individual::prm##_next>(other,                \
		                                                                         "merge_" #prm);       \
	}                                                                                                \
	inline msl::Ref merge_without_lock_##prm(msl::Ref other)                                         \
	{                                                                                                \
		return this->generic_merge_subset<&msl::Individual::prm##_head,                                \
		                                  &msl::Individual::set_##prm##_head,                          \
		                                  &msl::Individual::prm##_next>(other, "merge_" #prm);         \
	}

#define FLT(prm)         /* nothing */
#define FLG(prm)         /* nothing */
#define CTG(prm, format) /* nothing */
#define PTR(prm)         /* nothing */
#include "msl-variables.cpp"
#undef PTR
#undef CTG
#undef FLG
#undef FLT
#undef LNK

	// The generic function member which removes the indidual from the subset.
	// ''head_ptr” is a pointer of the function member which returns the head flag.
	// ''set_head_ptr” is a pointer of the function member which sets the head flag.
	// ''next_ptr” is the data member which gives the next element in the subset.
	// Example of use:
	//       generic_lock_and_remove_subset<&msl::Individual::family_head,
	//                             &msl::Individual::set_family_head,
	//                             &msl::Individual::family_next>()
	template<bool (msl::Individual::*head_ptr)() const,
	         msl::Ref (msl::Individual::*set_head_ptr)(bool),
	         msl::Individual* msl::Individual::*next_ptr>
	void generic_lock_and_remove_subset(const char* f_name, const char* l_name)
	{
		// Scoped lock to ensure exclusive acces to data.
		std::lock_guard<std::mutex> lock{ msl::global_lock };
		// The individual is the head of the subset.
		if ((this->*head_ptr)()) {
			// The size of the subset is 1. Nothing to do.
			if (this->*next_ptr == this)
				return;
			// The head of the subset will be the next in the subset.
			auto new_head_ptr{ this->*next_ptr };
			if (new_head_ptr == nullptr) {
				std::cerr << "Oups" << std::endl;
				exit(1);
			}
			(new_head_ptr->*set_head_ptr)(true);
			auto ptr{ new_head_ptr };
			// Go to the end of the list.
			size_t n{};
			while (ptr->*next_ptr != this) {
				ptr = ptr->*next_ptr;
				if (ptr == nullptr) {
					std::cerr << "Oups 1" << std::endl;
					// dump(*this);
					exit(1);
				}
				if (++n > 10000) {
					std::cerr << "Oups 2" << std::endl;
					// dump(*this);
					exit(1);
				}
			}
			ptr->*next_ptr = new_head_ptr;
			return;
		}
		// Go to the previous individual in the list.
		auto ptr{ this };
		size_t n{};
		while (ptr->*next_ptr != this) {
			ptr = ptr->*next_ptr;
			if (ptr == nullptr) {
				std::cerr << "Individual Oups 3 " << f_name << ' ' << l_name << std::endl;
				// dump(*this);
				exit(1);
			}
			if (++n > 10000) {
				std::cerr << "Oups 4" << std::endl;
				// dump(*this);
				MSL_SHOW(f_name)
				exit(1);
			}
		}
		ptr->*next_ptr = this->*next_ptr;
	}
	void death(const char* f_name = "death")
	{
#define LNK(prm)                                                                                   \
	generic_lock_and_remove_subset<&msl::Individual::prm##_head,                                     \
	                               &msl::Individual::set_##prm##_head,                               \
	                               &msl::Individual::prm##_next>(f_name, #prm);                      \
	this->prm##_next = nullptr;                                                                      \
	this->prm##_weight = std::numeric_limits<float>::quiet_NaN();
#define FLT(prm) this->prm = std::numeric_limits<float>::quiet_NaN();
#define FLG(prm) /* nothing */
#define CTG(prm, format) this->prm = 0;
		// If the relationship represented by the PTR is a symetric one, then set the ''prm” data member
		// to nullptr for the two individuals.
#define PTR(prm)                                                                                   \
	{                                                                                                \
		/* Scoped lock to ensure exclusive acces to data.*/                                            \
		std::lock_guard<std::mutex> lock{ msl::global_lock };                                          \
		if ((this->prm != nullptr) && (this->prm->prm == this))                                        \
			this->prm->prm = nullptr;                                                                    \
		this->prm = nullptr;                                                                           \
	}
#include "msl-variables.cpp"
#undef PTR
#undef CTG
#undef FLG
#undef FLT
#undef LNK
		this->flags_.reset();
		this->set_one(true).set_alive(false).set_id_number(0);
	}
	msl::Ref create(int birthday, size_t id_number)
	{
		if (this->alive())
			throw msl::Exception{
				"the individual is an alive one in the Individual::create(...) function member"
			};
		this->set_alive(true).set_birthday(birthday).set_id_number(id_number);
		// Put the individual in a valid state: for now, she is the only member of all subsets.
#define LNK(prm)                                                                                   \
	this->set_##prm##_head(true);                                                                    \
	this->prm##_next = this;
#define FLT(prm)         /* nothing */
#define FLG(prm)         /* nothing */
#define CTG(prm, format) /* nothing */
#define PTR(prm)         /* nothing */
#include "msl-variables.cpp"
#undef PTR
#undef CTG
#undef FLG
#undef FLT
#undef LNK
		return *this;
	}
	// Only the declaration as we need the ''dump'' function.
	double age() const;
}; // struct Individual
